'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _typeof(obj) {
  if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
    _typeof = function (obj) {
      return typeof obj;
    };
  } else {
    _typeof = function (obj) {
      return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
    };
  }

  return _typeof(obj);
}

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) {
  try {
    var info = gen[key](arg);
    var value = info.value;
  } catch (error) {
    reject(error);
    return;
  }

  if (info.done) {
    resolve(value);
  } else {
    Promise.resolve(value).then(_next, _throw);
  }
}

function _asyncToGenerator(fn) {
  return function () {
    var self = this,
        args = arguments;
    return new Promise(function (resolve, reject) {
      var gen = fn.apply(self, args);

      function _next(value) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value);
      }

      function _throw(err) {
        asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err);
      }

      _next(undefined);
    });
  };
}

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function _slicedToArray(arr, i) {
  return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
}

function _toConsumableArray(arr) {
  return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread();
}

function _arrayWithoutHoles(arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  }
}

function _arrayWithHoles(arr) {
  if (Array.isArray(arr)) return arr;
}

function _iterableToArray(iter) {
  if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter);
}

function _iterableToArrayLimit(arr, i) {
  var _arr = [];
  var _n = true;
  var _d = false;
  var _e = undefined;

  try {
    for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
      _arr.push(_s.value);

      if (i && _arr.length === i) break;
    }
  } catch (err) {
    _d = true;
    _e = err;
  } finally {
    try {
      if (!_n && _i["return"] != null) _i["return"]();
    } finally {
      if (_d) throw _e;
    }
  }

  return _arr;
}

function _nonIterableSpread() {
  throw new TypeError("Invalid attempt to spread non-iterable instance");
}

function _nonIterableRest() {
  throw new TypeError("Invalid attempt to destructure non-iterable instance");
}

function type(a) {
  var typeOf = _typeof(a);

  if (a === null) {
    return 'Null';
  } else if (a === undefined) {
    return 'Undefined';
  } else if (typeOf === 'boolean') {
    return 'Boolean';
  } else if (typeOf === 'number') {
    return 'Number';
  } else if (typeOf === 'string') {
    return 'String';
  } else if (Array.isArray(a)) {
    return 'Array';
  } else if (a instanceof RegExp) {
    return 'RegExp';
  }

  var asStr = a.toString();

  if (asStr.startsWith('async')) {
    return 'Async';
  } else if (asStr === '[object Promise]') {
    return 'Promise';
  } else if (asStr.includes('function') || asStr.includes('=>')) {
    return 'Function';
  }

  return 'Object';
}

function allFalse() {
  var counter = 0;

  for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
    inputs[_key] = arguments[_key];
  }

  while (counter < inputs.length) {
    var x = inputs[counter];

    if (type(x) === 'Function') {
      if (inputs[counter]()) {
        return false;
      }
    } else if (inputs[counter]) {
      return false;
    }

    counter++;
  }

  return true;
}

function allTrue() {
  var counter = 0;

  for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
    inputs[_key] = arguments[_key];
  }

  while (counter < inputs.length) {
    var x = inputs[counter];

    if (type(x) === 'Function') {
      if (!inputs[counter]()) {
        return false;
      }
    } else if (!inputs[counter]) {
      return false;
    }

    counter++;
  }

  return true;
}

/**Used as the `TypeError` message for "Functions" methods. */
var FUNC_ERROR_TEXT = 'Expected a function';
/**Used to stand-in for `undefined` hash values. */

var HASH_UNDEFINED = '__lodash_hash_undefined__';
/**Used as references for various `Number` constants. */

var INFINITY = 1 / 0,
    MAX_SAFE_INTEGER = 9007199254740991;
/**`Object#toString` result references. */

var funcTag = '[object Function]',
    genTag = '[object GeneratorFunction]',
    symbolTag = '[object Symbol]';
/**Used to match property names within property paths. */

var reIsDeepProp = /\.|\[(?:[^[\]]*|(["'])(?:(?!\1)[^\\]|\\.)*?\1)\]/,
    reIsPlainProp = /^\w*$/,
    reLeadingDot = /^\./,
    rePropName = /[^.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|$))/g;
/**
 * Used to match `RegExp`
 * [syntax characters](http://ecma-international.org/ecma-262/7.0/#sec-patterns).
 */

var reRegExpChar = /[\\^$.*+?()[\]{}|]/g;
/**Used to match backslashes in property paths. */

var reEscapeChar = /\\(\\)?/g;
/**Used to detect host constructors (Safari). */

var reIsHostCtor = /^\[object .+?Constructor\]$/;
/**Used to detect unsigned integer values. */

var reIsUint = /^(?:0|[1-9]\d*)$/;
/**Detect free variable `global` from Node.js. */

var freeGlobal = (typeof global === "undefined" ? "undefined" : _typeof(global)) === 'object' && global && global.Object === Object && global;
/**Detect free variable `self`. */

var freeSelf = (typeof self === "undefined" ? "undefined" : _typeof(self)) === 'object' && self && self.Object === Object && self;
/**Used as a reference to the global object. */

var root = freeGlobal || freeSelf || Function('return this')();
/**
 * Gets the value at `key` of `object`.
 *
 * @private
 * @param {Object} [object] The object to query.
 * @param {string} key The key of the property to get.
 * @returns {*} Returns the property value.
 */

function getValue(object, key) {
  return object == null ? undefined : object[key];
}
/**
 * Checks if `value` is a host object in IE < 9.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a host object, else `false`.
 */


function isHostObject(value) {
  //Many host objects are `Object` objects that can coerce to strings
  //despite having improperly defined `toString` methods.
  var result = false;

  if (value != null && typeof value.toString !== 'function') {
    try {
      result = Boolean(String(value));
    } catch (e) {}
  }

  return result;
}
/**Used for built-in method references. */


var arrayProto = Array.prototype,
    funcProto = Function.prototype,
    objectProto = Object.prototype;
/**Used to detect overreaching core-js shims. */

var coreJsData = root['__core-js_shared__'];
/**Used to detect methods masquerading as native. */

var maskSrcKey = function () {
  var uid = /[^.]+$/.exec(coreJsData && coreJsData.keys && coreJsData.keys.IE_PROTO || '');
  return uid ? 'Symbol(src)_1.' + uid : '';
}();
/**Used to resolve the decompiled source of functions. */


var funcToString = funcProto.toString;
/**Used to check objects for own properties. */

var hasOwnProperty = objectProto.hasOwnProperty;
/**
 * Used to resolve the
 * [`toStringTag`](http://ecma-international.org/ecma-262/7.0/#sec-object.prototype.tostring)
 * of values.
 */

var objectToString = objectProto.toString;
/**Used to detect if a method is native. */

var reIsNative = RegExp('^' + funcToString.call(hasOwnProperty).replace(reRegExpChar, '\\$&').replace(/hasOwnProperty|(function).*?(?=\\\()| for .+?(?=\\\])/g, '$1.*?') + '$');
/**Built-in value references. */

var _Symbol = root.Symbol,
    splice = arrayProto.splice;
/*Built-in method references that are verified to be native. */

var Map$1 = getNative(root, 'Map'),
    nativeCreate = getNative(Object, 'create');
/**Used to convert symbols to primitives and strings. */

var symbolProto = _Symbol ? _Symbol.prototype : undefined,
    symbolToString = symbolProto ? symbolProto.toString : undefined;
/**
 * Creates a hash object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function Hash(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();

  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
/**
 * Removes all key-value entries from the hash.
 *
 * @private
 * @name clear
 * @memberOf Hash
 */


function hashClear() {
  this.__data__ = nativeCreate ? nativeCreate(null) : {};
}
/**
 * Removes `key` and its value from the hash.
 *
 * @private
 * @name delete
 * @memberOf Hash
 * @param {Object} hash The hash to modify.
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */


function hashDelete(key) {
  return this.has(key) && delete this.__data__[key];
}
/**
 * Gets the hash value for `key`.
 *
 * @private
 * @name get
 * @memberOf Hash
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */


function hashGet(key) {
  var data = this.__data__;

  if (nativeCreate) {
    var result = data[key];
    return result === HASH_UNDEFINED ? undefined : result;
  }

  return hasOwnProperty.call(data, key) ? data[key] : undefined;
}
/**
 * Checks if a hash value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf Hash
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */


function hashHas(key) {
  var data = this.__data__;
  return nativeCreate ? data[key] !== undefined : hasOwnProperty.call(data, key);
}
/**
 * Sets the hash `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf Hash
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the hash instance.
 */


function hashSet(key, value) {
  var data = this.__data__;
  data[key] = nativeCreate && value === undefined ? HASH_UNDEFINED : value;
  return this;
} //Add methods to `Hash`.


Hash.prototype.clear = hashClear;
Hash.prototype.delete = hashDelete;
Hash.prototype.get = hashGet;
Hash.prototype.has = hashHas;
Hash.prototype.set = hashSet;
/**
 * Creates an list cache object.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function ListCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();

  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
/**
 * Removes all key-value entries from the list cache.
 *
 * @private
 * @name clear
 * @memberOf ListCache
 */


function listCacheClear() {
  this.__data__ = [];
}
/**
 * Removes `key` and its value from the list cache.
 *
 * @private
 * @name delete
 * @memberOf ListCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */


function listCacheDelete(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    return false;
  }

  var lastIndex = data.length - 1;

  if (index == lastIndex) {
    data.pop();
  } else {
    splice.call(data, index, 1);
  }

  return true;
}
/**
 * Gets the list cache value for `key`.
 *
 * @private
 * @name get
 * @memberOf ListCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */


function listCacheGet(key) {
  var data = this.__data__,
      index = assocIndexOf(data, key);
  return index < 0 ? undefined : data[index][1];
}
/**
 * Checks if a list cache value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf ListCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */


function listCacheHas(key) {
  return assocIndexOf(this.__data__, key) > -1;
}
/**
 * Sets the list cache `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf ListCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the list cache instance.
 */


function listCacheSet(key, value) {
  var data = this.__data__,
      index = assocIndexOf(data, key);

  if (index < 0) {
    data.push([key, value]);
  } else {
    data[index][1] = value;
  }

  return this;
} //Add methods to `ListCache`.


ListCache.prototype.clear = listCacheClear;
ListCache.prototype.delete = listCacheDelete;
ListCache.prototype.get = listCacheGet;
ListCache.prototype.has = listCacheHas;
ListCache.prototype.set = listCacheSet;
/**
 * Creates a map cache object to store key-value pairs.
 *
 * @private
 * @constructor
 * @param {Array} [entries] The key-value pairs to cache.
 */

function MapCache(entries) {
  var index = -1,
      length = entries ? entries.length : 0;
  this.clear();

  while (++index < length) {
    var entry = entries[index];
    this.set(entry[0], entry[1]);
  }
}
/**
 * Removes all key-value entries from the map.
 *
 * @private
 * @name clear
 * @memberOf MapCache
 */


function mapCacheClear() {
  this.__data__ = {
    hash: new Hash(),
    map: new (Map$1 || ListCache)(),
    string: new Hash()
  };
}
/**
 * Removes `key` and its value from the map.
 *
 * @private
 * @name delete
 * @memberOf MapCache
 * @param {string} key The key of the value to remove.
 * @returns {boolean} Returns `true` if the entry was removed, else `false`.
 */


function mapCacheDelete(key) {
  return getMapData(this, key).delete(key);
}
/**
 * Gets the map value for `key`.
 *
 * @private
 * @name get
 * @memberOf MapCache
 * @param {string} key The key of the value to get.
 * @returns {*} Returns the entry value.
 */


function mapCacheGet(key) {
  return getMapData(this, key).get(key);
}
/**
 * Checks if a map value for `key` exists.
 *
 * @private
 * @name has
 * @memberOf MapCache
 * @param {string} key The key of the entry to check.
 * @returns {boolean} Returns `true` if an entry for `key` exists, else `false`.
 */


function mapCacheHas(key) {
  return getMapData(this, key).has(key);
}
/**
 * Sets the map `key` to `value`.
 *
 * @private
 * @name set
 * @memberOf MapCache
 * @param {string} key The key of the value to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns the map cache instance.
 */


function mapCacheSet(key, value) {
  getMapData(this, key).set(key, value);
  return this;
} //Add methods to `MapCache`.


MapCache.prototype.clear = mapCacheClear;
MapCache.prototype.delete = mapCacheDelete;
MapCache.prototype.get = mapCacheGet;
MapCache.prototype.has = mapCacheHas;
MapCache.prototype.set = mapCacheSet;
/**
 * Assigns `value` to `key` of `object` if the existing value is not equivalent
 * using [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * for equality comparisons.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {string} key The key of the property to assign.
 * @param {*} value The value to assign.
 */

function assignValue(object, key, value) {
  var objValue = object[key];

  if (!(hasOwnProperty.call(object, key) && eq(objValue, value)) || value === undefined && !(key in object)) {
    object[key] = value;
  }
}
/**
 * Gets the index at which the `key` is found in `array` of key-value pairs.
 *
 * @private
 * @param {Array} array The array to inspect.
 * @param {*} key The key to search for.
 * @returns {number} Returns the index of the matched value, else `-1`.
 */


function assocIndexOf(array, key) {
  var length = array.length;

  while (length--) {
    if (eq(array[length][0], key)) {
      return length;
    }
  }

  return -1;
}
/**
 * The base implementation of `_.isNative` without bad shim checks.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a native function,
 *  else `false`.
 */


function baseIsNative(value) {
  if (!isObject(value) || isMasked(value)) {
    return false;
  }

  var pattern = isFunction(value) || isHostObject(value) ? reIsNative : reIsHostCtor;
  return pattern.test(toSource(value));
}
/**
 * The base implementation of `_.set`.
 *
 * @private
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @param {Function} [customizer] The function to customize path creation.
 * @returns {Object} Returns `object`.
 */


function baseSet(object, path, value, customizer) {
  if (!isObject(object)) {
    return object;
  }

  path = isKey(path, object) ? [path] : castPath(path);
  var index = -1,
      length = path.length,
      lastIndex = length - 1,
      nested = object;

  while (nested != null && ++index < length) {
    var key = toKey(path[index]),
        newValue = value;

    if (index != lastIndex) {
      var objValue = nested[key];
      newValue = customizer ? customizer(objValue, key, nested) : undefined;

      if (newValue === undefined) {
        newValue = isObject(objValue) ? objValue : isIndex(path[index + 1]) ? [] : {};
      }
    }

    assignValue(nested, key, newValue);
    nested = nested[key];
  }

  return object;
}
/**
 * The base implementation of `_.toString` which doesn't convert nullish
 * values to empty strings.
 *
 * @private
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 */


function baseToString(value) {
  //Exit early for strings to avoid a performance hit in some environments.
  if (typeof value === 'string') {
    return value;
  }

  if (isSymbol(value)) {
    return symbolToString ? symbolToString.call(value) : '';
  }

  var result = String(value);
  return result == '0' && 1 / value == -INFINITY ? '-0' : result;
}
/**
 * Casts `value` to a path array if it's not one.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {Array} Returns the cast property path array.
 */


function castPath(value) {
  return isArray(value) ? value : stringToPath(value);
}
/**
 * Gets the data for `map`.
 *
 * @private
 * @param {Object} map The map to query.
 * @param {string} key The reference key.
 * @returns {*} Returns the map data.
 */


function getMapData(map, key) {
  var data = map.__data__;
  return isKeyable(key) ? data[typeof key === 'string' ? 'string' : 'hash'] : data.map;
}
/**
 * Gets the native function at `key` of `object`.
 *
 * @private
 * @param {Object} object The object to query.
 * @param {string} key The key of the method to get.
 * @returns {*} Returns the function if it's native, else `undefined`.
 */


function getNative(object, key) {
  var value = getValue(object, key);
  return baseIsNative(value) ? value : undefined;
}
/**
 * Checks if `value` is a valid array-like index.
 *
 * @private
 * @param {*} value The value to check.
 * @param {number} [length=MAX_SAFE_INTEGER] The upper bounds of a valid index.
 * @returns {boolean} Returns `true` if `value` is a valid index, else `false`.
 */


function isIndex(value, length) {
  length = length == null ? MAX_SAFE_INTEGER : length;
  return Boolean(length) && (typeof value === 'number' || reIsUint.test(value)) && value > -1 && value % 1 == 0 && value < length;
}
/**
 * Checks if `value` is a property name and not a property path.
 *
 * @private
 * @param {*} value The value to check.
 * @param {Object} [object] The object to query keys on.
 * @returns {boolean} Returns `true` if `value` is a property name, else `false`.
 */


function isKey(value, object) {
  if (isArray(value)) {
    return false;
  }

  var type = _typeof(value);

  if (type == 'number' || type == 'symbol' || type == 'boolean' || value == null || isSymbol(value)) {
    return true;
  }

  return reIsPlainProp.test(value) || !reIsDeepProp.test(value) || object != null && value in Object(object);
}
/**
 * Checks if `value` is suitable for use as unique object key.
 *
 * @private
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is suitable, else `false`.
 */


function isKeyable(value) {
  var type = _typeof(value);

  return type == 'string' || type == 'number' || type == 'symbol' || type == 'boolean' ? value !== '__proto__' : value === null;
}
/**
 * Checks if `func` has its source masked.
 *
 * @private
 * @param {Function} func The function to check.
 * @returns {boolean} Returns `true` if `func` is masked, else `false`.
 */


function isMasked(func) {
  return Boolean(maskSrcKey) && maskSrcKey in func;
}
/**
 * Converts `string` to a property path array.
 *
 * @private
 * @param {string} string The string to convert.
 * @returns {Array} Returns the property path array.
 */


var stringToPath = memoize(function (string) {
  string = toString(string);
  var result = [];

  if (reLeadingDot.test(string)) {
    result.push('');
  }

  string.replace(rePropName, function (match, number, quote, string) {
    result.push(quote ? string.replace(reEscapeChar, '$1') : number || match);
  });
  return result;
});
/**
 * Converts `value` to a string key if it's not a string or symbol.
 *
 * @private
 * @param {*} value The value to inspect.
 * @returns {string|symbol} Returns the key.
 */

function toKey(value) {
  if (typeof value === 'string' || isSymbol(value)) {
    return value;
  }

  var result = String(value);
  return result == '0' && 1 / value == -INFINITY ? '-0' : result;
}
/**
 * Converts `func` to its source code.
 *
 * @private
 * @param {Function} func The function to process.
 * @returns {string} Returns the source code.
 */


function toSource(func) {
  if (func != null) {
    try {
      return funcToString.call(func);
    } catch (e) {}

    try {
      return String(func);
    } catch (e) {}
  }

  return '';
}
/**
 * Creates a function that memoizes the result of `func`. If `resolver` is
 * provided, it determines the cache key for storing the result based on the
 * arguments provided to the memoized function. By default, the first argument
 * provided to the memoized function is used as the map cache key. The `func`
 * is invoked with the `this` binding of the memoized function.
 *
 * **Note:** The cache is exposed as the `cache` property on the memoized
 * function. Its creation may be customized by replacing the `_.memoize.Cache`
 * constructor with one whose instances implement the
 * [`Map`](http://ecma-international.org/ecma-262/7.0/#sec-properties-of-the-map-prototype-object)
 * method interface of `delete`, `get`, `has`, and `set`.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Function
 * @param {Function} func The function to have its output memoized.
 * @param {Function} [resolver] The function to resolve the cache key.
 * @returns {Function} Returns the new memoized function.
 * @example
 *
 * var object = { 'a': 1, 'b': 2 };
 * var other = { 'c': 3, 'd': 4 };
 *
 * var values = _.memoize(_.values);
 * values(object);
 * // => [1, 2]
 *
 * values(other);
 * // => [3, 4]
 *
 * object.a = 2;
 * values(object);
 * // => [1, 2]
 *
 * // Modify the result cache.
 * values.cache.set(object, ['a', 'b']);
 * values(object);
 * // => ['a', 'b']
 *
 * // Replace `_.memoize.Cache`.
 * _.memoize.Cache = WeakMap;
 */


function memoize(func, resolver) {
  if (typeof func !== 'function' || resolver && typeof resolver !== 'function') {
    throw new TypeError(FUNC_ERROR_TEXT);
  }

  var memoized = function memoized() {
    var args = arguments,
        key = resolver ? resolver.apply(this, args) : args[0],
        cache = memoized.cache;

    if (cache.has(key)) {
      return cache.get(key);
    }

    var result = func.apply(this, args);
    memoized.cache = cache.set(key, result);
    return result;
  };

  memoized.cache = new (memoize.Cache || MapCache)();
  return memoized;
} //Assign cache to `_.memoize`.


memoize.Cache = MapCache;
/**
 * Performs a
 * [`SameValueZero`](http://ecma-international.org/ecma-262/7.0/#sec-samevaluezero)
 * comparison between two values to determine if they are equivalent.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to compare.
 * @param {*} other The other value to compare.
 * @returns {boolean} Returns `true` if the values are equivalent, else `false`.
 * @example
 *
 * var object = { 'a': 1 };
 * var other = { 'a': 1 };
 *
 * _.eq(object, object);
 * // => true
 *
 * _.eq(object, other);
 * // => false
 *
 * _.eq('a', 'a');
 * // => true
 *
 * _.eq('a', Object('a'));
 * // => false
 *
 * _.eq(NaN, NaN);
 * // => true
 */

function eq(value, other) {
  return value === other || value !== value && other !== other;
}
/**
 * Checks if `value` is classified as an `Array` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an array, else `false`.
 * @example
 *
 * _.isArray([1, 2, 3]);
 * // => true
 *
 * _.isArray(document.body.children);
 * // => false
 *
 * _.isArray('abc');
 * // => false
 *
 * _.isArray(_.noop);
 * // => false
 */


var isArray = Array.isArray;
/**
 * Checks if `value` is classified as a `Function` object.
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a function, else `false`.
 * @example
 *
 * _.isFunction(_);
 * // => true
 *
 * _.isFunction(/abc/);
 * // => false
 */

function isFunction(value) {
  //The use of `Object#toString` avoids issues with the `typeof` operator
  //in Safari 8-9 which returns 'object' for typed array and other constructors.
  var tag = isObject(value) ? objectToString.call(value) : '';
  return tag == funcTag || tag == genTag;
}
/**
 * Checks if `value` is the
 * [language type](http://www.ecma-international.org/ecma-262/7.0/#sec-ecmascript-language-types)
 * of `Object`. (e.g. arrays, functions, objects, regexes, `new Number(0)`, and `new String('')`)
 *
 * @static
 * @memberOf _
 * @since 0.1.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is an object, else `false`.
 * @example
 *
 * _.isObject({});
 * // => true
 *
 * _.isObject([1, 2, 3]);
 * // => true
 *
 * _.isObject(_.noop);
 * // => true
 *
 * _.isObject(null);
 * // => false
 */


function isObject(value) {
  var type = _typeof(value);

  return Boolean(value) && (type == 'object' || type == 'function');
}
/**
 * Checks if `value` is object-like. A value is object-like if it's not `null`
 * and has a `typeof` result of "object".
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is object-like, else `false`.
 * @example
 *
 * _.isObjectLike({});
 * // => true
 *
 * _.isObjectLike([1, 2, 3]);
 * // => true
 *
 * _.isObjectLike(_.noop);
 * // => false
 *
 * _.isObjectLike(null);
 * // => false
 */


function isObjectLike(value) {
  return Boolean(value) && _typeof(value) === 'object';
}
/**
 * Checks if `value` is classified as a `Symbol` primitive or object.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to check.
 * @returns {boolean} Returns `true` if `value` is a symbol, else `false`.
 * @example
 *
 * _.isSymbol(Symbol.iterator);
 * // => true
 *
 * _.isSymbol('abc');
 * // => false
 */


function isSymbol(value) {
  return _typeof(value) === 'symbol' || isObjectLike(value) && objectToString.call(value) == symbolTag;
}
/**
 * Converts `value` to a string. An empty string is returned for `null`
 * and `undefined` values. The sign of `-0` is preserved.
 *
 * @static
 * @memberOf _
 * @since 4.0.0
 * @category Lang
 * @param {*} value The value to process.
 * @returns {string} Returns the string.
 * @example
 *
 * _.toString(null);
 * // => ''
 *
 * _.toString(-0);
 * // => '-0'
 *
 * _.toString([1, 2, 3]);
 * // => '1,2,3'
 */


function toString(value) {
  return value == null ? '' : baseToString(value);
}
/**
 * Sets the value at `path` of `object`. If a portion of `path` doesn't exist,
 * it's created. Arrays are created for missing index properties while objects
 * are created for all other missing properties. Use `_.setWith` to customize
 * `path` creation.
 *
 * **Note:** This method mutates `object`.
 *
 * @static
 * @memberOf _
 * @since 3.7.0
 * @category Object
 * @param {Object} object The object to modify.
 * @param {Array|string} path The path of the property to set.
 * @param {*} value The value to set.
 * @returns {Object} Returns `object`.
 * @example
 *
 * var object = { 'a': [{ 'b': { 'c': 3 } }] };
 *
 * _.set(object, 'a[0].b.c', 4);
 * console.log(object.a[0].b.c);
 * // => 4
 *
 * _.set(object, ['x', '0', 'y', 'z'], 5);
 * console.log(object.x[0].y.z);
 * // => 5
 */


function set$1(object, path, value) {
  return object == null ? object : baseSet(object, path, value);
}

var isObject$1 = function isObject(x) {
  var ok = x !== null && !Array.isArray(x) && _typeof(x) === 'object';

  if (!ok) {
    return false;
  }

  return Object.keys(x).length > 0;
};

function change(origin, pathRaw, rules) {
  var willReturn = JSON.parse(JSON.stringify(origin));

  if (!isObject$1(rules)) {
    set$1(willReturn, pathRaw, rules);
    return willReturn;
  }

  var path = pathRaw === '' ? '' : "".concat(pathRaw, ".");

  var _arr = Object.keys(rules);

  var _loop = function _loop() {
    var ruleKey = _arr[_i];
    var rule = rules[ruleKey];

    if (!isObject$1(rule)) {
      set$1(willReturn, "".concat(path).concat(ruleKey), rule);
      return "continue";
    }

    Object.keys(rule).filter(function (subruleKey) {
      return !isObject$1(rule[subruleKey]);
    }).map(function (subruleKey) {
      var subrule = rule[subruleKey];
      set$1(willReturn, "".concat(path).concat(ruleKey, ".").concat(subruleKey), subrule);
    });
    Object.keys(rule).filter(function (subruleKey) {
      return isObject$1(rule[subruleKey]);
    }).map(function (subruleKey) {
      var subrule = rule[subruleKey];
      Object.keys(subrule).map(function (deepKey) {
        var deep = rule[subruleKey][deepKey];
        set$1(willReturn, "".concat(path).concat(ruleKey, ".").concat(subruleKey, ".").concat(deepKey), deep);
      });
    });
  };

  for (var _i = 0; _i < _arr.length; _i++) {
    var _ret = _loop();

    if (_ret === "continue") continue;
  }

  return willReturn;
}

function equals(a, b) {
  if (arguments.length === 1) {
    return function (bHolder) {
      return equals(a, bHolder);
    };
  }

  if (a === b) {
    return true;
  }

  var aType = type(a);

  if (aType !== type(b)) {
    return false;
  }

  if (aType === 'Array') {
    var aClone = Array.from(a);
    var bClone = Array.from(b);

    if (aClone.toString() !== bClone.toString()) {
      return false;
    }

    var loopArrayFlag = true;
    aClone.forEach(function (aCloneInstance, aCloneIndex) {
      if (loopArrayFlag) {
        if (aCloneInstance !== bClone[aCloneIndex] && !equals(aCloneInstance, bClone[aCloneIndex])) {
          loopArrayFlag = false;
        }
      }
    });
    return loopArrayFlag;
  }

  if (aType === 'Object') {
    var aKeys = Object.keys(a);

    if (aKeys.length !== Object.keys(b).length) {
      return false;
    }

    var loopObjectFlag = true;
    aKeys.forEach(function (aKeyInstance) {
      if (loopObjectFlag) {
        var aValue = a[aKeyInstance];
        var bValue = b[aKeyInstance];

        if (aValue !== bValue && !equals(aValue, bValue)) {
          loopObjectFlag = false;
        }
      }
    });
    return loopObjectFlag;
  }

  return false;
}

function filterObject(fn, obj) {
  var willReturn = {};

  for (var prop in obj) {
    if (fn(obj[prop], prop)) {
      willReturn[prop] = obj[prop];
    }
  }

  return willReturn;
}

function filter(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return filter(fn, arrHolder);
    };
  }

  if (arr === undefined) {
    return [];
  }

  if (!Array.isArray(arr)) {
    return filterObject(fn, arr);
  }

  var index = -1;
  var resIndex = 0;
  var len = arr.length;
  var willReturn = [];

  while (++index < len) {
    var value = arr[index];

    if (fn(value)) {
      willReturn[resIndex++] = value;
    }
  }

  return willReturn;
}

var types = ['Null', 'Undefined', 'RegExp'];
function compact(arr) {
  return filter(function (a) {
    var currentType = type(a);

    if (types.includes(currentType)) {
      return false;
    }

    if (currentType === 'Object') {
      return !equals(a, {});
    }

    return a.length !== 0;
  }, arr);
}

function composeAsync() {
  for (var _len = arguments.length, inputArguments = new Array(_len), _key = 0; _key < _len; _key++) {
    inputArguments[_key] = arguments[_key];
  }

  return (
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(startArgument) {
        var argumentsToPass, fn, typeFn;
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                argumentsToPass = startArgument;

              case 1:
                if (!(inputArguments.length !== 0)) {
                  _context.next = 13;
                  break;
                }

                fn = inputArguments.pop();
                typeFn = type(fn);

                if (!(typeFn === 'Async' || typeFn === 'Promise')) {
                  _context.next = 10;
                  break;
                }

                _context.next = 7;
                return fn(argumentsToPass);

              case 7:
                argumentsToPass = _context.sent;
                _context.next = 11;
                break;

              case 10:
                argumentsToPass = fn(argumentsToPass);

              case 11:
                _context.next = 1;
                break;

              case 13:
                return _context.abrupt("return", argumentsToPass);

              case 14:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }()
  );
}

function defaultWhen(fn, fallback, input) {
  if (arguments.length === 2) {
    return function (inputHolder) {
      return defaultWhen(fn, fallback, inputHolder);
    };
  }

  return fn(input) ? input : fallback;
}

function debounce(func, ms) {
  var immediate = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;
  var timeout;
  return function () {
    for (var _len = arguments.length, input = new Array(_len), _key = 0; _key < _len; _key++) {
      input[_key] = arguments[_key];
    }

    var later = function later() {
      timeout = null;

      if (!immediate) {
        func.apply(null, input);
      }
    };

    var callNow = immediate && !timeout;
    clearTimeout(timeout);
    timeout = setTimeout(later, ms);

    if (callNow) {
      func.apply(null, input);
    }
  };
}

function delay(ms) {
  return new Promise(function (resolve) {
    setTimeout(function () {
      resolve('RAMBDAX_DELAY');
    }, ms);
  });
}

//taken from the last comment of https://gist.github.com/mkuklis/5294248
function curry(f) {
  var a = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
  return function () {
    for (var _len = arguments.length, p = new Array(_len), _key = 0; _key < _len; _key++) {
      p[_key] = arguments[_key];
    }

    return function (o) {
      return o.length >= f.length ? f.apply(void 0, _toConsumableArray(o)) : curry(f, o);
    }(_toConsumableArray(a).concat(p));
  };
}

function evolveFn(rules, input) {
  var clone = Object.assign({}, input);
  var propRules = filter(function (x) {
    return clone[x] !== undefined;
  })(Object.keys(rules));

  if (propRules.length === 0) {
    return input;
  }

  propRules.map(function (prop) {
    var fn = rules[prop];

    if (type(fn) === 'Function') {
      clone[prop] = fn(clone[prop]);
    } else if (type(fn) === 'Object') {
      clone[prop] = evolve(fn, clone[prop]);
    }
  });
  return clone;
}

var evolve = curry(evolveFn);

function findInObject(fn, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return findInObject(fn, objHolder);
    };
  }

  var willReturn = {
    fallback: true
  };
  Object.entries(obj).map(function (_ref) {
    var _ref2 = _slicedToArray(_ref, 2),
        prop = _ref2[0],
        value = _ref2[1];

    if (willReturn.fallback) {
      if (fn(value, prop)) {
        willReturn = {
          prop: prop,
          value: value
        };
      }
    }
  });
  return willReturn;
}

function greater(x, y) {
  if (y === undefined) {
    return function (yHolder) {
      return greater(x, yHolder);
    };
  }

  return y > x;
}

function headObject(x) {
  if (type(x) !== 'Object') throw new Error('R.headObject.type');

  var _Object$keys = Object.keys(x),
      _Object$keys2 = _slicedToArray(_Object$keys, 2),
      tag = _Object$keys2[0],
      no = _Object$keys2[1];

  if (tag === undefined) throw new Error('R.headObject.less');
  if (no !== undefined) throw new Error('R.headObject.more');
  return {
    prop: tag,
    value: x[tag]
  };
}

function createThenable(x) {
  return (
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(input) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", x(input));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }()
  );
}

function ifElseAsync(condition, ifFn, elseFn) {
  return function (input) {
    return new Promise(function (resolve, reject) {
      var conditionPromise = createThenable(condition);
      var ifFnPromise = createThenable(ifFn);
      var elseFnPromise = createThenable(elseFn);
      conditionPromise(input).then(function (conditionResult) {
        var promised = conditionResult === true ? ifFnPromise : elseFnPromise;
        promised(input).then(resolve).catch(reject);
      }).catch(reject);
    });
  };
}

function replace(regex, replacer, str) {
  if (replacer === undefined) {
    return function (replacerHolder, strHolder) {
      return replace(regex, replacerHolder, strHolder);
    };
  } else if (str === undefined) {
    return function (strHolder) {
      return replace(regex, replacer, strHolder);
    };
  }

  return str.replace(regex, replacer);
}

function inject(injection, marker, content) {
  return replace(marker, "".concat(marker).concat(injection), content);
}

function intersection(a, b) {
  if (b === undefined) {
    return function (bHolder) {
      return intersection(a, bHolder);
    };
  }

  return filter(function (val) {
    return b.includes(val);
  })(a);
}

function any(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return any(fn, arrHolder);
    };
  }

  var counter = 0;

  while (counter < arr.length) {
    if (fn(arr[counter], counter)) {
      return true;
    }

    counter++;
  }

  return false;
}

function toLower(x) {
  return x.toLowerCase();
}

function contains(x, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return contains(x, arrHolder);
    };
  }

  var index = -1;
  var flag = false;

  while (++index < arr.length && !flag) {
    if (equals(arr[index], x)) {
      flag = true;
    }
  }

  return flag;
}

function test$1(regex, str) {
  if (arguments.length === 1) return function (strHolder) {
    return test$1(regex, strHolder);
  };
  return str.search(regex) !== -1;
}

function all(condition, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return all(condition, arrHolder);
    };
  }

  return filter(condition, arr).length === arr.length;
}

function baseSlice(array, start, end) {
  var index = -1;
  var length = array.length;
  end = end > length ? length : end;

  if (end < 0) {
    end += length;
  }

  length = start > end ? 0 : end - start >>> 0;
  start >>>= 0;
  var result = Array(length);

  while (++index < length) {
    result[index] = array[index + start];
  }

  return result;
}

function init(a) {
  if (typeof a === 'string') {
    return a.slice(0, -1);
  }

  return a.length ? baseSlice(a, 0, -1) : [];
}

function isValid(_ref) {
  var input = _ref.input,
      schema = _ref.schema;
  if (input === undefined || schema === undefined) return false;
  var flag = true;

  var boom = function boom(boomFlag) {
    if (!boomFlag) {
      flag = false;
    }
  };

  for (var requirementRaw in schema) {
    if (flag) {
      var isOptional = requirementRaw.endsWith('?');
      var requirement = isOptional ? init(requirementRaw) : requirementRaw;
      var rule = schema[requirementRaw];
      var ruleType = type(rule);
      var inputProp = input[requirement];
      var inputPropType = type(input[requirement]);
      var ok = isOptional && inputProp !== undefined || !isOptional;
      if (!ok || rule === 'any' && inputProp != null) continue;

      if (ruleType === 'Object') {
        /**
         * This rule is standalone schema, so we recursevly call `isValid`
         */
        var isValidResult = isValid({
          input: inputProp,
          schema: rule
        });
        boom(isValidResult);
      } else if (ruleType === 'String') {
        /**
         * rule is actual rule such as 'number', so the two types are compared
         */
        boom(toLower(inputPropType) === rule);
      } else if (typeof rule === 'function') {
        /**
         * rule is function so we pass to it the input
         */
        boom(rule(inputProp));
      } else if (ruleType === 'Array' && inputPropType === 'String') {
        /**
         * enum case | rule is like a: ['foo', 'bar']
         */
        boom(contains(inputProp, rule));
      } else if (ruleType === 'Array' && rule.length === 1 && inputPropType === 'Array') {
        (function () {
          /**
           * 1. array of type | rule is like a: ['number']
           * 2. rule is like a: [{from: 'string'}]
           */
          var currentRule = rule[0];
          var currentRuleType = type(rule[0]); //Check if rule is invalid

          boom(currentRuleType === 'String' || currentRuleType === 'Object');

          if (currentRuleType === 'String') {
            /**
             * 1. array of type
             */
            var isInvalidResult = any(function (inputPropInstance) {
              return type(inputPropInstance).toLowerCase() !== currentRule;
            }, inputProp);
            boom(!isInvalidResult);
          }

          if (currentRuleType === 'Object') {
            /**
             * 2. rule is like a: [{from: 'string'}]
             */
            var _isValidResult = all(function (inputPropInstance) {
              return isValid({
                input: inputPropInstance,
                schema: currentRule
              });
            }, inputProp);

            boom(_isValidResult);
          }
        })();
      } else if (ruleType === 'RegExp' && inputPropType === 'String') {
        boom(test$1(rule, inputProp));
      } else {
        boom(false);
      }
    }
  }

  return flag;
}

var holder = {};
function okInit(rules) {
  if (!rules) throw new Error('R.okInit !rules');
  if (rules._internal) return holder;
  holder = rules;
}

function check(singleInput, schema) {
  return isValid({
    input: {
      singleInput: singleInput
    },
    schema: {
      singleInput: schema
    }
  });
}
var holder$1 = {};
function ok() {
  for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
    inputs[_key] = arguments[_key];
  }

  if (Object.keys(holder$1).length === 0) {
    holder$1 = okInit({
      _internal: true
    });
  }

  return function () {
    for (var _len2 = arguments.length, schemas = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      schemas[_key2] = arguments[_key2];
    }

    if (inputs.length !== schemas.length) {
      throw new Error('inputs.length !== schemas.length');
    }

    var failedSchema;
    var pass = any(function (singleInput, i) {
      var isCustomSchema = allTrue(typeof schemas[i] === 'string', holder$1[schemas[i]]);
      var schema = isCustomSchema ? holder$1[schemas[i]] : schemas[i];
      var checked = check(singleInput, schema);

      if (!checked) {
        failedSchema = JSON.stringify({
          input: singleInput,
          schema: schema
        });
      }

      return !checked;
    }, inputs) === false;
    if (!pass) throw new Error("Failed R.ok with schema ".concat(failedSchema));
    return true;
  };
}

var holder$2 = {};
function is() {
  for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
    inputs[_key] = arguments[_key];
  }

  if (Object.keys(holder$2).length === 0) {
    holder$2 = okInit({
      _internal: true
    });
  }

  return function () {
    for (var _len2 = arguments.length, schemas = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      schemas[_key2] = arguments[_key2];
    }

    if (inputs.length !== schemas.length) return false;
    return any(function (singleInput, i) {
      var isCustomSchema = allTrue(typeof schemas[i] === 'string', holder$2[schemas[i]]);
      var schema = isCustomSchema ? holder$2[schemas[i]] : schemas[i];
      return !check(singleInput, schema);
    }, inputs) === false;
  };
}

function isAttach() {
  if (Object.prototype.is !== undefined) {
    return false;
  }

  Object.defineProperty(Object.prototype, 'is', {
    value: function value(schema) {
      return isValid({
        input: {
          isProp: this
        },
        schema: {
          isProp: schema
        }
      });
    },
    writable: true,
    configurable: true
  });
  return true;
}

function isFunction$1(fn) {
  return ['Async', 'Promise', 'Function'].includes(type(fn));
}

function isPromise(x) {
  return ['Async', 'Promise'].includes(type(x));
}

function isType(xType, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return isType(xType, xHolder);
    };
  }

  return type(x) === xType;
}

function less(x, y) {
  if (y === undefined) {
    return function (yHolder) {
      return less(x, yHolder);
    };
  }

  return y < x;
}

function mapAsyncFn(_x, _x2) {
  return _mapAsyncFn.apply(this, arguments);
}

function _mapAsyncFn() {
  _mapAsyncFn = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(fn, arr) {
    var _willReturn, _iteratorNormalCompletion, _didIteratorError, _iteratorError, _iterator, _step, a, willReturn, prop;

    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;

            if (!Array.isArray(arr)) {
              _context2.next = 33;
              break;
            }

            _willReturn = [];
            _iteratorNormalCompletion = true;
            _didIteratorError = false;
            _iteratorError = undefined;
            _context2.prev = 6;
            _iterator = arr[Symbol.iterator]();

          case 8:
            if (_iteratorNormalCompletion = (_step = _iterator.next()).done) {
              _context2.next = 18;
              break;
            }

            a = _step.value;
            _context2.t0 = _willReturn;
            _context2.next = 13;
            return fn(a);

          case 13:
            _context2.t1 = _context2.sent;

            _context2.t0.push.call(_context2.t0, _context2.t1);

          case 15:
            _iteratorNormalCompletion = true;
            _context2.next = 8;
            break;

          case 18:
            _context2.next = 24;
            break;

          case 20:
            _context2.prev = 20;
            _context2.t2 = _context2["catch"](6);
            _didIteratorError = true;
            _iteratorError = _context2.t2;

          case 24:
            _context2.prev = 24;
            _context2.prev = 25;

            if (!_iteratorNormalCompletion && _iterator.return != null) {
              _iterator.return();
            }

          case 27:
            _context2.prev = 27;

            if (!_didIteratorError) {
              _context2.next = 30;
              break;
            }

            throw _iteratorError;

          case 30:
            return _context2.finish(27);

          case 31:
            return _context2.finish(24);

          case 32:
            return _context2.abrupt("return", _willReturn);

          case 33:
            willReturn = {};
            _context2.t3 = regeneratorRuntime.keys(arr);

          case 35:
            if ((_context2.t4 = _context2.t3()).done) {
              _context2.next = 42;
              break;
            }

            prop = _context2.t4.value;
            _context2.next = 39;
            return fn(arr[prop], prop);

          case 39:
            willReturn[prop] = _context2.sent;
            _context2.next = 35;
            break;

          case 42:
            return _context2.abrupt("return", willReturn);

          case 45:
            _context2.prev = 45;
            _context2.t5 = _context2["catch"](0);
            throw _context2.t5;

          case 48:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 45], [6, 20, 24, 32], [25,, 27, 31]]);
  }));
  return _mapAsyncFn.apply(this, arguments);
}

function mapAsync(fn, arr) {
  if (arr === undefined) {
    return (
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(holder) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return mapAsyncFn(fn, holder);

                case 2:
                  return _context.abrupt("return", _context.sent);

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x3) {
          return _ref.apply(this, arguments);
        };
      }()
    );
  }

  return new Promise(function (resolve, reject) {
    mapAsyncFn(fn, arr).then(resolve).catch(reject);
  });
}

function mapFastAsyncFn(_x, _x2) {
  return _mapFastAsyncFn.apply(this, arguments);
}

function _mapFastAsyncFn() {
  _mapFastAsyncFn = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee2(fn, arr) {
    var promised;
    return regeneratorRuntime.wrap(function _callee2$(_context2) {
      while (1) {
        switch (_context2.prev = _context2.next) {
          case 0:
            _context2.prev = 0;
            promised = arr.map(function (a) {
              return fn(a);
            });
            _context2.next = 4;
            return Promise.all(promised);

          case 4:
            return _context2.abrupt("return", _context2.sent);

          case 7:
            _context2.prev = 7;
            _context2.t0 = _context2["catch"](0);
            throw _context2.t0;

          case 10:
          case "end":
            return _context2.stop();
        }
      }
    }, _callee2, this, [[0, 7]]);
  }));
  return _mapFastAsyncFn.apply(this, arguments);
}

function mapFastAsync(fn, arr) {
  if (arr === undefined) {
    return (
      /*#__PURE__*/
      function () {
        var _ref = _asyncToGenerator(
        /*#__PURE__*/
        regeneratorRuntime.mark(function _callee(holder) {
          return regeneratorRuntime.wrap(function _callee$(_context) {
            while (1) {
              switch (_context.prev = _context.next) {
                case 0:
                  _context.next = 2;
                  return mapFastAsyncFn(fn, holder);

                case 2:
                  return _context.abrupt("return", _context.sent);

                case 3:
                case "end":
                  return _context.stop();
              }
            }
          }, _callee, this);
        }));

        return function (_x3) {
          return _ref.apply(this, arguments);
        };
      }()
    );
  }

  return new Promise(function (resolve, reject) {
    mapFastAsyncFn(fn, arr).then(resolve).catch(reject);
  });
}

function compose() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return function () {
    var list = fns.slice();

    if (list.length > 0) {
      var fn = list.pop();
      var result = fn.apply(void 0, arguments);

      while (list.length > 0) {
        result = list.pop()(result);
      }

      return result;
    }

    return undefined;
  };
}

function mapObject(fn, obj) {
  var willReturn = {};

  for (var prop in obj) {
    willReturn[prop] = fn(obj[prop], prop);
  }

  return willReturn;
}

function map(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return map(fn, arrHolder);
    };
  }

  if (arr === undefined) {
    return [];
  }

  if (!Array.isArray(arr)) {
    return mapObject(fn, arr);
  }

  var index = -1;
  var len = arr.length;
  var willReturn = Array(len);

  while (++index < len) {
    willReturn[index] = fn(arr[index]);
  }

  return willReturn;
}

function sort(fn, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return sort(fn, arrHolder);
  };
  var arrClone = arr.concat();
  return arrClone.sort(fn);
}

function take(num, x) {
  if (arguments.length === 1) return function (xHolder) {
    return take(num, xHolder);
  };

  if (typeof x === 'string') {
    return x.slice(0, num);
  }

  return baseSlice(x, 0, num);
}

var cache = {};

var normalizeObject = function normalizeObject(obj) {
  var sortFn = function sortFn(a, b) {
    return a > b;
  };

  var willReturn = {};
  compose(map(function (prop) {
    return willReturn[prop] = obj[prop];
  }), sort(sortFn))(Object.keys(obj));
  return willReturn;
};

var stringify = function stringify(a) {
  if (type(a) === 'String') {
    return a;
  } else if (['Function', 'Async'].includes(type(a))) {
    var compacted = replace(/\s{1,}/g, ' ', a.toString());
    return replace(/\s/g, '_', take(15, compacted));
  } else if (type(a) === 'Object') {
    a = normalizeObject(a);
  }

  return JSON.stringify(a);
};

var generateProp = function generateProp(fn) {
  var propString = '';

  for (var _len = arguments.length, inputArguments = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
    inputArguments[_key - 1] = arguments[_key];
  }

  inputArguments.map(function (inputArgument) {
    propString += "".concat(stringify(inputArgument), "_");
  });
  return "".concat(propString).concat(stringify(fn));
};

function memoize$1(fn) {
  for (var _len2 = arguments.length, inputArguments = new Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
    inputArguments[_key2 - 1] = arguments[_key2];
  }

  if (arguments.length === 1) {
    return function () {
      for (var _len3 = arguments.length, inputArgumentsHolder = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
        inputArgumentsHolder[_key3] = arguments[_key3];
      }

      return memoize$1.apply(void 0, [fn].concat(inputArgumentsHolder));
    };
  }

  var prop = generateProp.apply(void 0, [fn].concat(inputArguments));

  if (prop in cache) {
    return cache[prop];
  }

  if (type(fn) === 'Async') {
    return new Promise(function (resolve) {
      fn.apply(void 0, inputArguments).then(function (result) {
        cache[prop] = result;
        resolve(result);
      });
    });
  }

  var result = fn.apply(void 0, inputArguments);
  cache[prop] = result;
  return result;
}

function merge(obj, newProps) {
  if (arguments.length === 1) {
    return function (newPropsHolder) {
      return merge(obj, newPropsHolder);
    };
  }

  return Object.assign({}, obj || {}, newProps || {});
}

function mergeAll(arr) {
  var willReturn = {};
  map(function (val) {
    willReturn = merge(willReturn, val);
  }, arr);
  return willReturn;
}

function mergeRight(x, y) {
  return merge(y, x);
}

function multiline(input, glue) {
  return input.split('\n').filter(function (x) {
    return x.trim().length > 0;
  }).map(function (x) {
    return x.trim();
  }).join(glue ? glue : ' ');
}

function omitBy(fn, obj) {
  if (arguments.length === 1) {
    return function (holder) {
      return omitBy(fn, holder);
    };
  }

  var willReturn = {};

  for (var prop in obj) {
    if (!fn(prop, obj[prop])) {
      willReturn[prop] = obj[prop];
    }
  }

  return willReturn;
}

function onceFn(fn, context) {
  var result;
  return function () {
    if (fn) {
      result = fn.apply(context || this, arguments);
      fn = null;
    }

    return result;
  };
}

function once(fn, context) {
  if (arguments.length === 1) {
    var wrap = onceFn(fn, context);
    return curry(wrap);
  }

  return onceFn(fn, context);
}

function pickBy(fn, obj) {
  if (arguments.length === 1) {
    return function (holder) {
      return pickBy(fn, holder);
    };
  }

  var willReturn = {};

  for (var prop in obj) {
    if (fn(prop, obj[prop])) {
      willReturn[prop] = obj[prop];
    }
  }

  return willReturn;
}

function helper(_ref) {
  var condition = _ref.condition,
      inputArgument = _ref.inputArgument,
      prop = _ref.prop;
  return new Promise(function (resolve, reject) {
    if (!(type(condition) === 'Async')) {
      return resolve({
        type: prop,
        payload: condition(inputArgument)
      });
    }

    condition(inputArgument).then(function (result) {
      resolve({
        type: prop,
        payload: result
      });
    }).catch(function (err) {
      return reject(err);
    });
  });
}

function produce(conditions, inputArgument) {
  if (arguments.length === 1) {
    return function (inputArgumentHolder) {
      return produce(conditions, inputArgumentHolder);
    };
  }

  var asyncConditionsFlag = false;

  for (var prop in conditions) {
    if (asyncConditionsFlag === false && type(conditions[prop]) === 'Async') {
      asyncConditionsFlag = true;
    }
  }

  if (asyncConditionsFlag === false) {
    var willReturn = {};

    for (var _prop in conditions) {
      willReturn[_prop] = conditions[_prop](inputArgument);
    }

    return willReturn;
  }

  var promised = [];

  for (var _prop2 in conditions) {
    var condition = conditions[_prop2];
    promised.push(helper({
      inputArgument: inputArgument,
      condition: condition,
      prop: _prop2
    }));
  }

  return new Promise(function (resolve, reject) {
    Promise.all(promised).then(function (results) {
      var willReturn = {};
      map(function (result) {
        return willReturn[result.type] = result.payload;
      }, results);
      resolve(willReturn);
    }).catch(function (err) {
      return reject(err);
    });
  });
}

function promiseAllObject(promises) {
  return new Promise(function (res, rej) {
    var counter = 0;
    var props = {};
    var promisedArr = [];

    for (var prop in promises) {
      props[counter] = prop;
      promisedArr.push(promises[prop]);
      counter++;
    }

    Promise.all(promisedArr).then(function (result) {
      var willReturn = {};
      result.map(function (val, key) {
        var prop = props[key];
        willReturn[prop] = val;
      });
      res(willReturn);
    }).catch(rej);
  });
}

var promiseAllSecureWrapper = function promiseAllSecureWrapper(promise) {
  return new Promise(function (res) {
    promise.then(function (result) {
      res({
        payload: result,
        type: 'RESULT'
      });
    }).catch(function (err) {
      res({
        payload: err,
        type: 'ERROR'
      });
    });
  });
};

function promiseAllSecure(_x) {
  return _promiseAllSecure.apply(this, arguments);
}

function _promiseAllSecure() {
  _promiseAllSecure = _asyncToGenerator(
  /*#__PURE__*/
  regeneratorRuntime.mark(function _callee(input) {
    var promised;
    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.prev = 0;
            promised = map(function (a) {
              return promiseAllSecureWrapper(a);
            }, input);
            _context.next = 4;
            return Promise.all(promised);

          case 4:
            return _context.abrupt("return", _context.sent);

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](0);
            console.log(_context.t0);

          case 10:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, this, [[0, 7]]);
  }));
  return _promiseAllSecure.apply(this, arguments);
}

function random(min, max) {
  return Math.floor(Math.random() * (max - min + 1)) + min;
}

function range(start, end) {
  if (arguments.length === 1) return function (endHolder) {
    return range(start, endHolder);
  };
  var willReturn = [];

  for (var i = start; i < end; i++) {
    willReturn.push(i);
  }

  return willReturn;
}

function length(x) {
  return x.length;
}

function last(a) {
  if (typeof a === 'string') {
    return a[a.length - 1] || '';
  }

  return a[a.length - 1];
}

function split(glue, str) {
  if (arguments.length === 1) return function (strHolder) {
    return split(glue, strHolder);
  };
  return str.split(glue);
}

function rangeBy(startNum, endNum, distance) {
  var isInteger = !distance.toString().includes('.');

  if (startNum > endNum) {
    var startNumHolder = startNum;
    startNum = endNum;
    endNum = startNumHolder;
  }

  var willReturn = [startNum];
  var valueToPush = startNum;

  if (isInteger) {
    var loopIndexes = range(0, Math.floor((endNum - startNum) / distance));
    var _iteratorNormalCompletion = true;
    var _didIteratorError = false;
    var _iteratorError = undefined;

    try {
      for (var _iterator = loopIndexes[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
        var i = _step.value;
        valueToPush += distance;
        willReturn.push(valueToPush);
      }
    } catch (err) {
      _didIteratorError = true;
      _iteratorError = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion && _iterator.return != null) {
          _iterator.return();
        }
      } finally {
        if (_didIteratorError) {
          throw _iteratorError;
        }
      }
    }
  } else {
    var decimalLength = compose(length, last, split('.'))(distance.toString());

    var _loopIndexes = range(0, Math.floor((endNum - startNum) / distance));

    var _iteratorNormalCompletion2 = true;
    var _didIteratorError2 = false;
    var _iteratorError2 = undefined;

    try {
      for (var _iterator2 = _loopIndexes[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
        var _i = _step2.value;
        valueToPush += distance;
        willReturn.push(Number(valueToPush.toFixed(decimalLength)));
      }
    } catch (err) {
      _didIteratorError2 = true;
      _iteratorError2 = err;
    } finally {
      try {
        if (!_iteratorNormalCompletion2 && _iterator2.return != null) {
          _iterator2.return();
        }
      } finally {
        if (_didIteratorError2) {
          throw _iteratorError2;
        }
      }
    }
  }

  return willReturn;
}

function remove(inputs, text) {
  if (type(inputs) !== 'Array') {
    return replace(inputs, '', text).trim();
  }

  var textCopy = text;
  inputs.forEach(function (singleInput) {
    textCopy = replace(singleInput, '', textCopy).trim();
  });
  return textCopy;
}

function omit(keys, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return omit(keys, objHolder);
    };
  }

  if (obj === null || obj === undefined) {
    return undefined;
  }

  var keysValue = typeof keys === 'string' ? keys = keys.split(',') : keys;
  var willReturn = {};

  for (var key in obj) {
    if (!keysValue.includes(key)) {
      willReturn[key] = obj[key];
    }
  }

  return willReturn;
}

function renameProps(conditions, inputObject) {
  if (inputObject === undefined) {
    return function (inputObjectHolder) {
      return renameProps(conditions, inputObjectHolder);
    };
  }

  var renamed = {};
  Object.keys(conditions).map(function (renameConditionProp) {
    if (Object.keys(inputObject).includes(renameConditionProp)) {
      renamed[conditions[renameConditionProp]] = inputObject[renameConditionProp];
    }
  });
  return merge(renamed, omit(Object.keys(conditions), inputObject));
}

var getOccurances = function getOccurances(input) {
  return input.match(/{{[_a-zA-Z0-9]+}}/g);
};

var getOccuranceProp = function getOccuranceProp(occurance) {
  return occurance.replace(/{{|}}/g, '');
};

var replace$1 = function replace(_ref) {
  var inputHolder = _ref.inputHolder,
      prop = _ref.prop,
      replacer = _ref.replacer;
  return inputHolder.replace("{{".concat(prop, "}}"), replacer);
};

function template(input, templateInput) {
  var occurances = getOccurances(input);
  if (occurances === null) return input;
  var inputHolder = input;
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = occurances[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var occurance = _step.value;
      var prop = getOccuranceProp(occurance);
      var replacer = templateInput[prop];
      if (replacer === undefined) continue;
      inputHolder = replace$1({
        inputHolder: inputHolder,
        prop: prop,
        replacer: replacer
      });
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return != null) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return inputHolder;
}

var evaluationsSchema = {
  label: 'string'
};
function runTests(input) {
  var pass = ok(input)({
    testSuite: 'string',
    evaluations: [evaluationsSchema]
  });

  if (describe === undefined || !pass) {
    throw new Error('R.runTests.init');
  }

  try {
    var testSuite = input.testSuite,
        evaluations = input.evaluations,
        data = input.data;
    describe(testSuite, function () {
      evaluations.forEach(function (singleEvaluation) {
        data.forEach(function (dataInstance) {
          var _headObject = headObject(dataInstance),
              tag = _headObject.prop,
              x = _headObject.value;

          var _headObject2 = headObject(omit('label', singleEvaluation)),
              evaluationFunction = _headObject2.value;

          var label = template(singleEvaluation.label, {
            tag: tag
          });
          test(label, function () {
            evaluationFunction(x);
          });
        });
      });
    });
  } catch (err) {
    console.log(err);
    throw new Error('R.runTestsCatch');
  }
}

//https://github.com/staltz/zii
function s() {
  if (Object.prototype.s === undefined) {
    Object.defineProperty(Object.prototype, 's', {
      value: function value(f) {
        return f(this.valueOf());
      },
      writable: true,
      configurable: true
    });
    return true;
  }

  return false;
}

function shuffle(arrayRaw) {
  var array = arrayRaw.concat();
  var counter = array.length;

  while (counter > 0) {
    var index = Math.floor(Math.random() * counter);
    counter--;
    var temp = array[counter];
    array[counter] = array[index];
    array[index] = temp;
  }

  return array;
}

var NO_MATCH_FOUND = Symbol ? Symbol('NO_MATCH_FOUND') : undefined;

var getMatchingKeyValuePair = function getMatchingKeyValuePair(cases, testValue, defaultValue) {
  var iterationValue;

  for (var index = 0; index < cases.length; index++) {
    iterationValue = cases[index].test(testValue);

    if (iterationValue !== NO_MATCH_FOUND) {
      return iterationValue;
    }
  }

  return defaultValue;
};

var isEqual = function isEqual(testValue, matchValue) {
  var willReturn = typeof testValue === 'function' ? testValue(matchValue) : equals(testValue, matchValue);
  return willReturn;
};

var _is = function is(testValue) {
  var matchResult = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
  return {
    key: testValue,
    test: function test(matchValue) {
      return isEqual(testValue, matchValue) ? matchResult : NO_MATCH_FOUND;
    }
  };
};

var Switchem =
/*#__PURE__*/
function () {
  function Switchem(defaultValue, cases, willMatch) {
    _classCallCheck(this, Switchem);

    if (defaultValue !== undefined && cases === undefined && willMatch === undefined) {
      this.cases = [];
      this.defaultValue = undefined;
      this.willMatch = defaultValue;
    } else {
      this.cases = cases;
      this.defaultValue = defaultValue;
      this.willMatch = willMatch;
    }

    return this;
  }

  _createClass(Switchem, [{
    key: "default",
    value: function _default(defaultValue) {
      var holder = new Switchem(defaultValue, this.cases, this.willMatch);
      return holder.match(this.willMatch);
    }
  }, {
    key: "is",
    value: function is(testValue, matchResult) {
      return new Switchem(this.defaultValue, _toConsumableArray(this.cases).concat([_is(testValue, matchResult)]), this.willMatch);
    }
  }, {
    key: "match",
    value: function match(matchValue) {
      return getMatchingKeyValuePair(this.cases, matchValue, this.defaultValue);
    }
  }]);

  return Switchem;
}();

function switcher(input) {
  return new Switchem(input);
}

function tapAsync(fn, input) {
  if (arguments.length === 1) {
    return function (inputHolder) {
      return tapAsync(fn, inputHolder);
    };
  }

  if (isPromise(fn) === true) {
    return new Promise(function (resolve, reject) {
      fn(input).then(function () {
        resolve(input);
      }).catch(reject);
    });
  }

  fn(input);
  return input;
}

function throttle(fn, ms) {
  var wait = false;
  return function () {
    if (!wait) {
      for (var _len = arguments.length, input = new Array(_len), _key = 0; _key < _len; _key++) {
        input[_key] = arguments[_key];
      }

      fn.apply(null, input);
      wait = true;
      setTimeout(function () {
        wait = false;
      }, ms);
    }
  };
}

function tryCatch(fn, fallback) {
  if (!isFunction$1(fn)) {
    throw new Error("R.tryCatch | fn '".concat(fn, "'"));
  }

  var passFallback = isFunction$1(fallback);

  if (!isPromise(fn)) {
    return function () {
      try {
        return fn.apply(void 0, arguments);
      } catch (e) {
        return passFallback ? fallback.apply(void 0, arguments) : fallback;
      }
    };
  }

  return function () {
    for (var _len = arguments.length, inputs = new Array(_len), _key = 0; _key < _len; _key++) {
      inputs[_key] = arguments[_key];
    }

    return new Promise(function (resolve) {
      fn.apply(void 0, inputs).then(resolve).catch(function () {
        if (!passFallback) {
          return resolve(fallback);
        }

        if (!isPromise(fallback)) {
          return resolve(fallback.apply(void 0, inputs));
        }

        fallback.apply(void 0, inputs).then(resolve);
      });
    });
  };
}

function validate(input, schema) {
  if (arguments.length === 2) {
    return isValid({
      input: input,
      schema: schema
    });
  }

  return function (schemaHolder) {
    return isValid({
      input: input,
      schema: schemaHolder
    });
  };
}

function when(condition, whenTrueFn) {
  if (whenTrueFn === undefined) {
    return function (whenTrueFnHolder) {
      return when(condition, whenTrueFnHolder);
    };
  }

  return function (input) {
    var flag = typeof condition === 'boolean' ? condition : condition(input);

    if (flag) {
      return whenTrueFn(input);
    }

    return input;
  };
}

function createThenable$1(x) {
  return (
    /*#__PURE__*/
    function () {
      var _ref = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee(input) {
        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                return _context.abrupt("return", x(input));

              case 1:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, this);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }()
  );
}

function whenAsync(condition, whenTrueFn) {
  if (whenTrueFn === undefined) {
    return function (condition, whenTrueFnHolder) {
      return whenAsync(condition, whenTrueFnHolder);
    };
  }

  return function (input) {
    return new Promise(function (resolve, reject) {
      var whenTrueFnPromise = createThenable$1(whenTrueFn);

      if (typeof condition === 'boolean') {
        if (condition === false) {
          return resolve(input);
        }

        whenTrueFn(input).then(resolve).catch(reject);
      } else {
        var conditionPromise = createThenable$1(condition);
        conditionPromise(input).then(function (conditionResult) {
          if (conditionResult === false) {
            return resolve(input);
          }

          whenTrueFn(input).then(resolve).catch(reject);
        }).catch(reject);
      }
    });
  };
}

function where(conditions, obj) {
  if (obj === undefined) {
    return function (objHolder) {
      return where(conditions, objHolder);
    };
  }

  var flag = true;

  for (var prop in conditions) {
    var result = conditions[prop](obj[prop]);

    if (flag && result === false) {
      flag = false;
    }
  }

  return flag;
}

function add(x, y) {
  if (y === undefined) {
    return function (yHolder) {
      return add(x, yHolder);
    };
  }

  return x + y;
}

function addIndex(functor) {
  return function (fn) {
    var cnt = 0;

    var newFn = function newFn() {
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }

      return fn.apply(null, args.concat([cnt++]));
    };

    for (var _len = arguments.length, rest = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      rest[_key - 1] = arguments[_key];
    }

    return functor.apply(null, [newFn].concat(rest));
  };
}

function adjust(fn, index, arr) {
  if (index === undefined) {
    return function (indexHolder, arrHolder) {
      return adjust(fn, indexHolder, arrHolder);
    };
  } else if (arr === undefined) {
    return function (arrHolder) {
      return adjust(fn, index, arrHolder);
    };
  }

  var clone = arr.concat();
  return clone.map(function (val, key) {
    if (key === index) {
      return fn(arr[index]);
    }

    return val;
  });
}

function allPass(conditions, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return allPass(conditions, xHolder);
    };
  }

  return !any(function (condition) {
    return !condition(x);
  }, conditions);
}

function always(x) {
  return function () {
    return x;
  };
}

function anyPass(conditions, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return anyPass(conditions, xHolder);
    };
  }

  return any(function (condition) {
    return condition(x);
  })(conditions);
}

function append(x, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return append(x, arrHolder);
    };
  }

  if (typeof arr === 'string') return "".concat(arr).concat(x);
  var clone = arr.concat();
  clone.push(x);
  return clone;
}

function assocRaw(prop, value, obj) {
  return Object.assign({}, obj, _defineProperty({}, prop, value));
}

var assoc = curry(assocRaw);

function both(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return both(x, yHolder);
    };
  }

  return function (input) {
    return x(input) && y(input);
  };
}

function complement(fn) {
  return function (input) {
    return !fn(input);
  };
}

function concat(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return concat(x, yHolder);
    };
  }

  return typeof x === 'string' ? "".concat(x).concat(y) : _toConsumableArray(x).concat(_toConsumableArray(y));
}

var dec = function dec(x) {
  return x - 1;
};

function defaultTo(defaultArgument, inputArgument) {
  if (arguments.length === 1) {
    return function (inputArgumentHolder) {
      return defaultTo(defaultArgument, inputArgumentHolder);
    };
  }

  return inputArgument === undefined || inputArgument === null || Number.isNaN(inputArgument) === true ? defaultArgument : inputArgument;
}

function dissoc(prop, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return dissoc(prop, objHolder);
    };
  }

  if (obj === null || obj === undefined) {
    return {};
  }

  var willReturn = {};

  for (var p in obj) {
    willReturn[p] = obj[p];
  }

  delete willReturn[prop];
  return willReturn;
}

function divide(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return divide(x, yHolder);
    };
  }

  return x / y;
}

function drop(dropNumber, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return drop(dropNumber, xHolder);
    };
  }

  return x.slice(dropNumber);
}

function dropLast(dropNumber, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return dropLast(dropNumber, xHolder);
    };
  }

  return x.slice(0, -dropNumber);
}

function either(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return either(x, yHolder);
    };
  }

  return function (input) {
    return x(input) || y(input);
  };
}

function endsWith(substr, str) {
  if (arguments.length === 1) {
    return function (strHolder) {
      return endsWith(substr, strHolder);
    };
  }

  return str.endsWith(substr);
}

function F() {
  return false;
}

function find(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return find(fn, arrHolder);
    };
  }

  return arr.find(fn);
}

function findIndex(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return findIndex(fn, arrHolder);
    };
  }

  var len = arr.length;
  var index = -1;

  while (++index < len) {
    if (fn(arr[index])) {
      return index;
    }
  }

  return -1;
}

function flatten(arr, willReturn) {
  willReturn = willReturn === undefined ? [] : willReturn;

  for (var i = 0; i < arr.length; i++) {
    if (Array.isArray(arr[i])) {
      flatten(arr[i], willReturn);
    } else {
      willReturn.push(arr[i]);
    }
  }

  return willReturn;
}

function flipExport(fn) {
  return function () {
    for (var _len = arguments.length, input = new Array(_len), _key = 0; _key < _len; _key++) {
      input[_key] = arguments[_key];
    }

    if (input.length === 1) {
      return function (holder) {
        return fn(holder, input[0]);
      };
    } else if (input.length === 2) {
      return fn(input[1], input[0]);
    }

    return undefined;
  };
}

function flip(fn) {
  return flipExport(fn);
}

function forEach(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return forEach(fn, arrHolder);
    };
  }

  map(fn, arr);
  return arr;
}

function groupBy(fn, list) {
  if (arguments.length === 1) {
    return function (list) {
      return groupBy(fn, list);
    };
  }

  var result = {};

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    var key = fn(item);

    if (!result[key]) {
      result[key] = [];
    }

    result[key].push(item);
  }

  return result;
}

function has(prop, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return has(prop, objHolder);
    };
  }

  return obj[prop] !== undefined;
}

function head(a) {
  if (typeof a === 'string') {
    return a[0] || '';
  }

  return a[0];
}

function identity(x) {
  return x;
}

function ifElse(condition, ifFn, elseFn) {
  if (ifFn === undefined) {
    return function (ifFnHolder, elseFnHolder) {
      return ifElse(condition, ifFnHolder, elseFnHolder);
    };
  } else if (elseFn === undefined) {
    return function (elseFnHolder) {
      return ifElse(condition, ifFn, elseFnHolder);
    };
  }

  return function (input) {
    var conditionResult = typeof condition === 'boolean' ? condition : condition(input);

    if (conditionResult === true) {
      return ifFn(input);
    }

    return elseFn(input);
  };
}

var inc = function inc(x) {
  return x + 1;
};

function includes(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return includes(x, yHolder);
    };
  }

  return y.includes(x);
}

function indexBy(fn, list) {
  if (arguments.length === 1) {
    return function (listHolder) {
      return indexBy(fn, listHolder);
    };
  }

  var result = {};

  for (var i = 0; i < list.length; i++) {
    var item = list[i];
    result[fn(item)] = item;
  }

  return result;
}

function indexOf(x, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return indexOf(x, arrHolder);
    };
  }

  var index = -1;
  var length = arr.length;

  while (++index < length) {
    if (arr[index] === x) {
      return index;
    }
  }

  return -1;
}

function isNil(x) {
  return x === undefined || x === null;
}

function join(glue, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return join(glue, arrHolder);
    };
  }

  return arr.join(glue);
}

function keys(x) {
  return Object.keys(x);
}

function lastIndexOf(x, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return lastIndexOf(x, arrHolder);
    };
  }

  var willReturn = -1;
  arr.map(function (value, key) {
    if (equals(value, x)) {
      willReturn = key;
    }
  });
  return willReturn;
}

function match(regex, x) {
  if (arguments.length === 1) {
    return function (xHolder) {
      return match(regex, xHolder);
    };
  }

  var willReturn = x.match(regex);
  return willReturn === null ? [] : willReturn;
}

function max(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return max(x, yHolder);
    };
  }

  return y > x ? y : x;
}

function maxBy(fn, x, y) {
  if (arguments.length === 2) {
    return function (yHolder) {
      return maxBy(fn, x, yHolder);
    };
  } else if (arguments.length === 1) {
    return function (xHolder, yHolder) {
      return maxBy(fn, xHolder, yHolder);
    };
  }

  return fn(y) > fn(x) ? y : x;
}

function min(x, y) {
  if (arguments.length === 1) {
    return function (yHolder) {
      return min(x, yHolder);
    };
  }

  return y < x ? y : x;
}

function minByRaw(fn, x, y) {
  return fn(y) < fn(x) ? y : x;
}

var minBy = curry(minByRaw);

function modulo(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return modulo(x, yHolder);
  };
  return x % y;
}

function multiply(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return multiply(x, yHolder);
  };
  return x * y;
}

function none(fn, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return none(fn, arrHolder);
  };
  return arr.filter(fn).length === 0;
}

function not(x) {
  return !x;
}

function nth(index, list) {
  if (arguments.length === 1) return function (listHolder) {
    return nth(index, listHolder);
  };
  var idx = index < 0 ? list.length + index : index;
  return Object.prototype.toString.call(list) === '[object String]' ? list.charAt(idx) : list[idx];
}

function partialCurry(fn) {
  var inputArguments = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  return function (inputArgumentsHolder) {
    if (type(fn) === 'Async' || type(fn) === 'Promise') {
      return new Promise(function (resolve, reject) {
        fn(merge(inputArgumentsHolder, inputArguments)).then(resolve).catch(reject);
      });
    }

    return fn(merge(inputArgumentsHolder, inputArguments));
  };
}

function path(pathArr, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return path(pathArr, objHolder);
    };
  }

  if (obj === null || obj === undefined) {
    return undefined;
  }

  var willReturn = obj;
  var counter = 0;
  var pathArrValue = typeof pathArr === 'string' ? pathArr.split('.') : pathArr;

  while (counter < pathArrValue.length) {
    if (willReturn === null || willReturn === undefined) {
      return undefined;
    }

    willReturn = willReturn[pathArrValue[counter]];
    counter++;
  }

  return willReturn;
}

function pathOrRaw(defaultValue, inputPath, inputObject) {
  return defaultTo(defaultValue, path(inputPath, inputObject));
}

var pathOr = curry(pathOrRaw);

function pick(keys, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return pick(keys, objHolder);
    };
  }

  if (obj === null || obj === undefined) {
    return undefined;
  }

  var keysValue = typeof keys === 'string' ? keys.split(',') : keys;
  var willReturn = {};
  var counter = 0;

  while (counter < keysValue.length) {
    if (keysValue[counter] in obj) {
      willReturn[keysValue[counter]] = obj[keysValue[counter]];
    }

    counter++;
  }

  return willReturn;
}

function pickAll(keys, obj) {
  if (arguments.length === 1) {
    return function (objHolder) {
      return pickAll(keys, objHolder);
    };
  }

  if (obj === null || obj === undefined) {
    return undefined;
  }

  var keysValue = typeof keys === 'string' ? keys.split(',') : keys;
  var willReturn = {};
  var counter = 0;

  while (counter < keysValue.length) {
    if (keysValue[counter] in obj) {
      willReturn[keysValue[counter]] = obj[keysValue[counter]];
    } else {
      willReturn[keysValue[counter]] = undefined;
    }

    counter++;
  }

  return willReturn;
}

function pipe() {
  for (var _len = arguments.length, fns = new Array(_len), _key = 0; _key < _len; _key++) {
    fns[_key] = arguments[_key];
  }

  return compose.apply(void 0, _toConsumableArray(fns.reverse()));
}

function pluck(keyToPluck, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return pluck(keyToPluck, arrHolder);
  };
  var willReturn = [];
  map(function (val) {
    if (!(val[keyToPluck] === undefined)) {
      willReturn.push(val[keyToPluck]);
    }
  }, arr);
  return willReturn;
}

function prepend(x, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return prepend(x, arrHolder);
  };

  if (typeof arr === 'string') {
    return "".concat(x).concat(arr);
  }

  var clone = arr.concat();
  clone.unshift(x);
  return clone;
}

function prop(key, obj) {
  if (arguments.length === 1) return function (objHolder) {
    return prop(key, objHolder);
  };
  return obj[key];
}

function propEq(key, x, obj) {
  if (x === undefined) {
    return function (xHolder, objHolder) {
      return propEq(key, xHolder, objHolder);
    };
  } else if (obj === undefined) {
    return function (objHolder) {
      return propEq(key, x, objHolder);
    };
  }

  return obj[key] === x;
}

function reduce(fn, initialValue, arr) {
  if (initialValue === undefined) {
    return function (initialValueHolder, arrHolder) {
      return reduce(fn, initialValueHolder, arrHolder);
    };
  } else if (arr === undefined) {
    return function (arrHolder) {
      return reduce(fn, initialValue, arrHolder);
    };
  }

  return arr.reduce(fn, initialValue);
}

function reject(fn, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return reject(fn, arrHolder);
  };
  return filter(function (x) {
    return !fn(x);
  }, arr);
}

function repeat(x, num) {
  if (arguments.length === 1) {
    return function (numHolder) {
      return repeat(x, numHolder);
    };
  }

  var willReturn = Array(num);
  return willReturn.fill(x);
}

function reverse(arr) {
  var clone = arr.concat();
  return clone.reverse();
}

function sortBy(fn, arr) {
  if (arguments.length === 1) {
    return function (arrHolder) {
      return sortBy(fn, arrHolder);
    };
  }

  var arrClone = arr.concat();
  return arrClone.sort(function (a, b) {
    var fnA = fn(a);
    var fnB = fn(b);
    return fnA < fnB ? -1 : fnA > fnB ? 1 : 0;
  });
}

function splitEvery(num, x) {
  if (arguments.length === 1) return function (xHolder) {
    return splitEvery(num, xHolder);
  };
  var numValue = num > 1 ? num : 1;
  var willReturn = [];
  var counter = 0;

  while (counter < x.length) {
    willReturn.push(x.slice(counter, counter += numValue));
  }

  return willReturn;
}

function startsWith(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return startsWith(x, yHolder);
  };
  return y.startsWith(x);
}

function subtract(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return subtract(x, yHolder);
  };
  return x - y;
}

function T() {
  return true;
}

function tail(arr) {
  return drop(1, arr);
}

function takeLast(num, x) {
  if (arguments.length === 1) return function (xHolder) {
    return takeLast(num, xHolder);
  };
  var len = x.length;
  var numValue = num > len ? len : num;

  if (typeof x === 'string') {
    return x.slice(len - numValue);
  }

  numValue = len - numValue;
  return baseSlice(x, numValue, len);
}

function tap(fn, x) {
  if (arguments.length === 1) return function (xHolder) {
    return tap(fn, xHolder);
  };
  fn(x);
  return x;
}

function times(fn, num) {
  if (arguments.length === 1) return function (numHolder) {
    return times(fn, numHolder);
  };
  return map(fn, range(0, num));
}

function toString$1(x) {
  return x.toString();
}

function toUpper(x) {
  return x.toUpperCase();
}

function trim(str) {
  return str.trim();
}

function uniq(arr) {
  var index = -1;
  var willReturn = [];

  while (++index < arr.length) {
    var value = arr[index];

    if (!contains(value, willReturn)) {
      willReturn.push(value);
    }
  }

  return willReturn;
}

function uniqWith(fn, arr) {
  if (arguments.length === 1) return function (arrHolder) {
    return uniqWith(fn, arrHolder);
  };
  var index = -1;
  var len = arr.length;
  var willReturn = [];

  var _loop = function _loop() {
    var value = arr[index];
    var flag = any(function (willReturnInstance) {
      return fn(value, willReturnInstance);
    }, willReturn);

    if (!flag) {
      willReturn.push(value);
    }
  };

  while (++index < arr.length) {
    _loop();
  }

  return willReturn;
}

function update(index, newValue, arr) {
  if (newValue === undefined) {
    return function (newValueHolder, arrHolder) {
      return update(index, newValueHolder, arrHolder);
    };
  } else if (arr === undefined) {
    return function (arrHolder) {
      return update(index, newValue, arrHolder);
    };
  }

  var arrClone = arr.concat();
  return arrClone.fill(newValue, index, index + 1);
}

function values(obj) {
  var willReturn = [];

  for (var key in obj) {
    willReturn.push(obj[key]);
  }

  return willReturn;
}

function without(itemsToOmit, collection) {
  return reduce(function (accum, item) {
    return !contains(item, itemsToOmit) ? accum.concat(item) : accum;
  }, [], collection);
}

function zip(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return zip(x, yHolder);
  };
  return addIndex(reduce)(function (accum, value, index) {
    return y[index] ? accum.concat([[value, y[index]]]) : accum;
  }, [], x);
}

function zipObj(x, y) {
  if (arguments.length === 1) return function (yHolder) {
    return zipObj(x, yHolder);
  };
  return x.reduce(function (prev, xInstance, i) {
    prev[xInstance] = y[i];
    return prev;
  }, {});
}

var DELAY = 'RAMBDAX_DELAY';

exports.DELAY = DELAY;
exports.ok = ok;
exports.allFalse = allFalse;
exports.allTrue = allTrue;
exports.change = change;
exports.compact = compact;
exports.composeAsync = composeAsync;
exports.defaultWhen = defaultWhen;
exports.debounce = debounce;
exports.delay = delay;
exports.evolve = evolve;
exports.findInObject = findInObject;
exports.greater = greater;
exports.headObject = headObject;
exports.ifElseAsync = ifElseAsync;
exports.inject = inject;
exports.intersection = intersection;
exports.is = is;
exports.isAttach = isAttach;
exports.isFunction = isFunction$1;
exports.isPromise = isPromise;
exports.isType = isType;
exports.isValid = isValid;
exports.less = less;
exports.mapAsync = mapAsync;
exports.mapFastAsync = mapFastAsync;
exports.memoize = memoize$1;
exports.mergeAll = mergeAll;
exports.mergeRight = mergeRight;
exports.multiline = multiline;
exports.okInit = okInit;
exports.omitBy = omitBy;
exports.once = once;
exports.pickBy = pickBy;
exports.produce = produce;
exports.promiseAllObject = promiseAllObject;
exports.promiseAllSecure = promiseAllSecure;
exports.random = random;
exports.rangeBy = rangeBy;
exports.remove = remove;
exports.renameProps = renameProps;
exports.runTests = runTests;
exports.s = s;
exports.shuffle = shuffle;
exports.switcher = switcher;
exports.tapAsync = tapAsync;
exports.template = template;
exports.throttle = throttle;
exports.tryCatch = tryCatch;
exports.validate = validate;
exports.when = when;
exports.whenAsync = whenAsync;
exports.where = where;
exports.add = add;
exports.addIndex = addIndex;
exports.adjust = adjust;
exports.all = all;
exports.allPass = allPass;
exports.always = always;
exports.any = any;
exports.anyPass = anyPass;
exports.append = append;
exports.assoc = assoc;
exports.both = both;
exports.complement = complement;
exports.compose = compose;
exports.concat = concat;
exports.contains = contains;
exports.curry = curry;
exports.dec = dec;
exports.defaultTo = defaultTo;
exports.dissoc = dissoc;
exports.divide = divide;
exports.drop = drop;
exports.dropLast = dropLast;
exports.either = either;
exports.endsWith = endsWith;
exports.equals = equals;
exports.F = F;
exports.filter = filter;
exports.find = find;
exports.findIndex = findIndex;
exports.flatten = flatten;
exports.flip = flip;
exports.forEach = forEach;
exports.groupBy = groupBy;
exports.has = has;
exports.head = head;
exports.identity = identity;
exports.ifElse = ifElse;
exports.inc = inc;
exports.includes = includes;
exports.indexBy = indexBy;
exports.indexOf = indexOf;
exports.init = init;
exports.isNil = isNil;
exports.join = join;
exports.keys = keys;
exports.last = last;
exports.lastIndexOf = lastIndexOf;
exports.length = length;
exports.map = map;
exports.match = match;
exports.merge = merge;
exports.max = max;
exports.maxBy = maxBy;
exports.min = min;
exports.minBy = minBy;
exports.modulo = modulo;
exports.multiply = multiply;
exports.none = none;
exports.not = not;
exports.nth = nth;
exports.omit = omit;
exports.partialCurry = partialCurry;
exports.path = path;
exports.pathOr = pathOr;
exports.pick = pick;
exports.pickAll = pickAll;
exports.pipe = pipe;
exports.pluck = pluck;
exports.prepend = prepend;
exports.prop = prop;
exports.propEq = propEq;
exports.range = range;
exports.reduce = reduce;
exports.reject = reject;
exports.repeat = repeat;
exports.replace = replace;
exports.reverse = reverse;
exports.sort = sort;
exports.sortBy = sortBy;
exports.split = split;
exports.splitEvery = splitEvery;
exports.startsWith = startsWith;
exports.subtract = subtract;
exports.T = T;
exports.tail = tail;
exports.take = take;
exports.takeLast = takeLast;
exports.tap = tap;
exports.test = test$1;
exports.times = times;
exports.toLower = toLower;
exports.toString = toString$1;
exports.toUpper = toUpper;
exports.trim = trim;
exports.type = type;
exports.uniq = uniq;
exports.uniqWith = uniqWith;
exports.update = update;
exports.values = values;
exports.without = without;
exports.zip = zip;
exports.zipObj = zipObj;
